Metadata-Version: 2.4
Name: apimatic-pnl-sdk
Version: 1.0.0
Summary: SDK for pnl
Author-email: Muhammad Rafay <muhammad.rafay@apimatic.io>
Project-URL: Documentation, https://jouw.postnl.nl/
Requires-Python: >=3.7
Description-Content-Type: text/markdown
License-File: LICENSE
Requires-Dist: apimatic-core>=0.2.24,~=0.2.0
Requires-Dist: apimatic-core-interfaces>=0.1.8,~=0.1.0
Requires-Dist: apimatic-requests-client-adapter>=0.1.10,~=0.1.0
Requires-Dist: python-dotenv<2.0,>=0.21
Provides-Extra: testutils
Requires-Dist: pytest>=7.2.2; extra == "testutils"
Dynamic: license-file

# Getting Started with Postnl-Ecommerce

## Introduction

PostNL Ecommerce APIs

Explore our technical documentation, test your integration and go live with PostNL service.

Start using PostNL APIs for e-commerce processes

To get to know the PostNL APIs better, read all about it in our API overview (https://developer.postnl.nl/api-overview/). Learn everything you need to about our API's before embarking on integration with PostNL.

To connect to PostNL, you can request an API key via Mijn PostNL (https://mijn.postnl.nl/c/BP2_Mod_Login.app?inresponseto=&RelayState=&startURL=%2F) portal. Choose your APIs and build your integration. Explore our guides, examples, and resources to guide you through each phase of integration and start testing. Ensure that you can make successful test calls towards all endpoints used in the solution.

Contact our integrations team to have your test calls reviewed and gain access to our API production environment. Once everything is configured and validated, you'll be ready to go live and start using the PostNL service.

For help contact us via our support form: Need help? Submit a case | PostNL (https://developer.postnl.nl/support/form/).

## Install the Package

The package is compatible with Python versions `3.7+`.
Install the package from PyPi using the following pip command:

```bash
pip install apimatic-pnl-sdk==1.0.0
```

You can also view the package at:
https://pypi.python.org/pypi/apimatic-pnl-sdk/1.0.0

## Test the SDK

You can test the generated SDK and the server with test cases. `unittest` is used as the testing framework and `pytest` is used as the test runner. You can run the tests as follows:

Navigate to the root directory of the SDK and run the following commands


pip install -r test-requirements.txt
pytest


## Initialize the API Client

**_Note:_** Documentation for the client can be found [here.](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/client.md)

The following parameters are configurable for the API Client:

| Parameter | Type | Description |
|  --- | --- | --- |
| environment | [`Environment`](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/README.md#environments) | The API environment. 
 **Default: `Environment.PRODUCTION_SERVER`** |
| http_client_instance | `Union[Session, HttpClientProvider]` | The Http Client passed from the sdk user for making requests |
| override_http_client_configuration | `bool` | The value which determines to override properties of the passed Http Client from the sdk user |
| http_call_back | `HttpCallBack` | The callback value that is invoked before and after an HTTP call is made to an endpoint |
| timeout | `float` | The value to use for connection timeout. 
 **Default: 60** |
| max_retries | `int` | The number of times to retry an endpoint call if it fails. 
 **Default: 3** |
| backoff_factor | `float` | A backoff factor to apply between attempts after the second try. 
 **Default: 2** |
| retry_statuses | `Array of int` | The http statuses on which retry is to be done. 
 **Default: [408, 413, 429, 500, 502, 503, 504, 521, 522, 524]** |
| retry_methods | `Array of string` | The http methods on which retry is to be done. 
 **Default: ["GET", "PUT"]** |
| proxy_settings | [`ProxySettings`](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/proxy-settings.md) | Optional proxy configuration to route HTTP requests through a proxy server. |
| custom_header_authentication_credentials | [`CustomHeaderAuthenticationCredentials`](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/auth/custom-header-signature.md) | The credential object for Custom Header Signature |

The API client can be initialized as follows:

### Code-Based Client Initialization

```python
from postnlecommerce.configuration import Environment
from postnlecommerce.http.auth.custom_header_authentication import CustomHeaderAuthenticationCredentials
from postnlecommerce.postnlecommerce_client import PostnlecommerceClient

client = PostnlecommerceClient(
    custom_header_authentication_credentials=CustomHeaderAuthenticationCredentials(
        apikey='apikey'
    ),
    environment=Environment.PRODUCTION_SERVER
)
```

### Environment-Based Client Initialization

```python
from postnlecommerce.postnlecommerce_client import PostnlecommerceClient

# Specify the path to your .env file if it’s located outside the project’s root directory.
client = PostnlecommerceClient.from_environment(dotenv_path='/path/to/.env')
```

See the [Environment-Based Client Initialization](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/environment-based-client-initialization.md) section for details.

## Environments

The SDK can be configured to use a different environment for making API calls. Available environments are:

### Fields

| Name | Description |
|  --- | --- |
| PRODUCTION_SERVER | **Default** Production server |
| NON_PRODUCTION_SERVER | Sandbox environment for testing |

## Authorization

This API uses the following authentication schemes.

* [`APIKeyHeader (Custom Header Signature)`](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/auth/custom-header-signature.md)

## List of APIs

* [Postalcodecheck](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/controllers/postalcodecheck.md)
* [Barcode](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/controllers/barcode.md)
* [Checkout](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/controllers/checkout.md)
* [Confirming](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/controllers/confirming.md)
* [Deliverydate](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/controllers/deliverydate.md)
* [Labelling](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/controllers/labelling.md)
* [Locations](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/controllers/locations.md)
* [Shipment](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/controllers/shipment.md)
* [Shipping Status](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/controllers/shipping-status.md)
* [Timeframes](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/controllers/timeframes.md)

## SDK Infrastructure

### Configuration

* [ProxySettings](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/proxy-settings.md)
* [Environment-Based Client Initialization](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/environment-based-client-initialization.md)

### HTTP

* [HttpResponse](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/http-response.md)
* [HttpRequest](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/http-request.md)

### Utilities

* [ApiResponse](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/api-response.md)
* [ApiHelper](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/api-helper.md)
* [HttpDateTime](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/http-date-time.md)
* [RFC3339DateTime](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/rfc3339-date-time.md)
* [UnixDateTime](https://www.github.com/sdks-io/apimatic-pnl-python-sdk/tree/1.0.0/doc/unix-date-time.md)

